/*
 * $Id: hooks.c,v 1.2 1997/03/01 17:42:51 athena Exp $
 */

/*
 * $Log: hooks.c,v $
 * Revision 1.2  1997/03/01 17:42:51  athena
 * Massive cleanup and merging --- since I was still using the
 * old repository :-(
 *
 */

/*
 * Copyright (c) 1996 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to use, copy, modify, and distribute the Software without
 * restriction, provided the Software, including any modified copies made
 * under this license, is not distributed for a fee, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE MASSACHUSETTS INSTITUTE OF TECHNOLOGY BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of the Massachusetts
 * Institute of Technology shall not be used in advertising or otherwise
 * to promote the sale, use or other dealings in this Software without
 * prior written authorization from the Massachusetts Institute of
 * Technology.
 *  
 */

/* hook manager */
#include <cilk.h>
#include <cilk-internal.h>
#include <stdlib.h>

void Cilk_add_hook(HookList **listp, HookT fn)
{
     HookList *new;

     new = (HookList *)malloc(sizeof (HookList));

     new->fn = fn;
     new->next = NULL_HOOK;

     /* traverse the list */
     while (*listp != NULL_HOOK)
	  listp = &((*listp)->next);

     /* append at the end */
     *listp = new;
}

void Cilk_run_hooks(HookList *list)
{
     for ( ; list != NULL_HOOK ; list = list->next) 
	  list->fn();
}
	  
/* declaration of the various hooks */
HookList *Cilk_init_global_hooks = NULL_HOOK;
HookList *Cilk_init_per_process_hooks = NULL_HOOK;
